<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Account
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Account
 * @subpackage  Model
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Account_Model_Customer_Row extends Ecart_Db_Table_Row  
{
    /**
     *
     * @return array
     */
    public function getDetails()
    {
        $select = $this->getAdapter()->select();
        
        $select->from(array('cd' => self::$_db_prefix . 'account_customer_detail'))
               ->where('cd.customer_id = ' . intval($this->id));
        
        return $this->getAdapter()->fetchAll($select->__toString());
    }
    
    /**
     *
     * @param name $fieldName
     * @param int $languageId
     * @return mixed
     */
    public function getExtraField($fieldName, $languageId = null)
    {
       
        if (!$languageId) {
            $languageId = Ecart::getLanguageId();
        }
        $select = $this->getAdapter()->select();
        $select->from(array('cd' => self::$_db_prefix . 'account_customer_detail'), array('customer_valueset_value_id' , 'data'))
               ->join(array('cf' => self::$_db_prefix . 'account_customer_field'), 
               'cd.customer_field_id = cf.id')
               ->where('cd.customer_id = ' . intval($this->id))
               ->where('cf.name =  ?', $fieldName);
        $rows = $this->getAdapter()->fetchAll($select->__toString());
        
        if (isset($rows[0]) && !empty($rows[0]['data'])){
            return $rows[0]['data'];
        } elseif (isset($rows[0]) && !empty($rows[0]['customer_valueset_value_id'])) {
            $valuesetIds = array();
            foreach ($rows as $row) {
                $valuesetIds[] = $row['customer_valueset_value_id'];
            }
            
            $select = $this->getAdapter()->select();
            $select->from(array('cvvl' => self::$_db_prefix . 'account_customer_valueset_value_label'), 'label')
                   ->where('cvvl.valueset_value_id IN  (?)', $valuesetIds)
                   ->where('cvvl.language_id =  ?', $languageId);

            return $this->getAdapter()->fetchCol($select->__toString());
        }
        return false;
    }
}