<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Account
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Account
 * @subpackage  Controller
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Account_IndexController extends Ecart_Account_Controller_Account
{
	public function indexAction()
	{
	    $this->view->pageTitle = Ecart::translate('account')->__('My Account');
        $this->view->meta()->setTitle(
            Ecart::translate('account')->__(
                'My Account'
        ));
	    $customer = Ecart::single('account/customer')
                ->find(Ecart::getCustomerId())->current();

        $this->view->customerName = $customer->firstname . ' '
            . $customer->lastname;
        $this->view->customerEmail = $customer->email;
        $this->render();
    }
}