<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Account
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Account
 * @subpackage  Controller
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Account_InfoController extends Ecart_Account_Controller_Account
{
    public function init()
    {
        parent::init();
        $this->view->crumbs()->add(
            Ecart::translate('account')->__('Information'), '/account/info'
        );
    }
    
    public function indexAction()
    {
    	$this->_redirect('account/info/change');
    }
    
    public function changeAction()
    {
        $this->view->pageTitle = Ecart::translate('account')->__('Change Info');
        $this->view->meta()->setTitle(
            Ecart::translate('account')->__(
                'Change account info'
        ));
        $form = Ecart::single('account/Form_ChangeInfo');
        
        if ($this->_request->isPost()) {
            $data = $this->_request->getPost();
            if ($data['change_password_toggle'] == 0) {
                $form->getElement('password_current')->clearValidators();// removeValidator('NotEmpty');
                $form->getElement('password')->clearValidators(); //removeValidator('NotEmpty');
                $form->getElement('password_confirm')->clearValidators(); //removeValidator('NotEmpty');
            }
            if ($form->isValid($data)) {
                Ecart::single('account/customer')->save(
                    Ecart::getCustomerId(), $data
                );
                Ecart::message()->addSuccess(
                    Ecart::translate('account')->__(
                        'Account settings successfully updated'
                ));
            }
        } else {
            $data = array();
            $customer = Ecart::single('account/customer')
                ->find(Ecart::getCustomerId())->current();
            $extraInfo = $customer->findDependentRowset(
                'Ecart_Account_Model_Customer_Detail'
            );
            $data = $customer->toArray();
            
            foreach ($extraInfo as $row) {
                $data['field_' . $row->customer_field_id] = empty($row->data) ?
                    $row->customer_valueset_value_id : $row->data;
            }
        }
        
        $form->populate($data);
        $this->view->form = $form;
        $this->render();
    }
    
}