<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Admin
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Admin
 * @subpackage  Box
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Admin_Box_Greeting extends Ecart_Admin_Box_Abstract 
{
    protected $_title = '';
    protected $_disableWrapper = true;
    
    public function init()
    {
        $date = new Ecart_Date();
        $todayDate = $date->toString();
        $date = $date->addDay(-1)->toString('YYYY-MM-dd');
        
        $mailCount = Ecart::single('contacts/message')
                        ->count('created_at > \'' . $date . '\'');
        

        $orderTotal = Ecart::single('sales/order')
                        ->getTotal("date_purchased_on > '{$date}'");

        $orderTotal = Ecart::single('locale/currency')
                        ->getCurrencyObject(Ecart::config()->main->store->currency)
                        ->toCurrency($orderTotal ? $orderTotal : 0);

        $orderCount = Ecart::single('sales/order')
                        ->count('date_purchased_on > \'' . $date . '\'');
        
        $userId = Zend_Auth::getInstance()->getIdentity();
        
        $this->updateData(array(
            'todayDate' => $todayDate,
            'mailCount' => $mailCount,
            'orderTotal'=> $orderTotal,
            'orderCount' => $orderCount,
            'userInfo' => Ecart::single('admin/user')->find($userId)->current()
        ));
    }   
}