<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Admin
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Admin
 * @subpackage  Model
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Admin_Model_Cms_Category extends Ecart_Cms_Model_Category
{
    protected $_rowClass = 'Ecart_Admin_Model_Cms_Category_Row';
    
    public function getRootCategory($siteId)
    {
        $select = $this->getAdapter()->select();
        $select->from(array('cc' => $this->_name), array('id', 'name', 'is_active'))
            ->where('cc.site_id = ?', $siteId)
            ->where('cc.parent_id is NULL');

        return $this->getAdapter()->fetchAssoc($select->__toString());
    }
    
    public function getChildCategory($nodeId)
    {
        $select = $this->getAdapter()->select();
        $select->from(array('cc' => $this->_name), array('id', 'name', 'is_active'))
            ->where('cc.parent_id = ?', $nodeId);

        return $this->getAdapter()->fetchAssoc($select->__toString());
    }
}