<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Admin
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Admin
 * @subpackage  Model
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Admin_Model_Cms_Page_Row extends Ecart_Cms_Model_Page_Row 
{
    public function getContent($includeBlocks = false)
    {
        $select = $this->getAdapter()->select();
        
        $select->from(array('cpc' => self::$_db_prefix . 'cms_page_content'))
               ->where('cpc.cms_page_id = ?', $this->id);
               
        return $select->query()->fetchAll();
    }
    
    public function getCategory()
    {
    	$select = $this->getAdapter()->select();
    	
    	$select->from(array('cptc' => self::$_db_prefix . 'cms_page_category'), 'cms_category_id')
    	       ->where('cptc.cms_page_id = ?', $this->id);

    	return $select->query()->fetchAll();       
    }
}