<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 *
 * @category    Ecart
 * @package     Ecart_Admin
 * @subpackage  Ecart_Admin_Model
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Admin_Model_Import_Profile extends Ecart_Db_Table 
{
    protected $_name = 'import_profile';
    
    public function getList()
    {
        $query = "SELECT *
                  FROM   $this->_name
                  ORDER BY updated_at DESC, created_at DESC";
                  
        return $this->getAdapter()->fetchAll($query);
    }
    
    public function save($data)
    {
        if ($data['id'] == '') {
            $data['created_at'] = Ecart_Date::now()->toZendDbExpr();
            $data['updated_at'] = '0000-00-00 00:00:00';
            unset($data['id']);
            $row = $this->createRow();
        } else {
            $data['updated_at'] = Ecart_Date::now()->toZendDbExpr();
            $row = $this->find($data['id'])->current();
        }
        $row->setFromArray($data);
        if ($result = $row->save()) {
            Ecart::message()->addSuccess(
                Ecart::translate('admin')->__(
                    'Profile was saved successfully'
                )
            );
        };
        return $result;
    }
    
    public function delete($data)
    {
        $where = $this->getAdapter()->quoteInto('id IN(?)', $data);
        
        if ($result = parent::delete($where)) {
            Ecart::message()->addSuccess(
                Ecart::translate('admin')->__(
                    'Profile was deleted successfully'
                )
            );
        };
        return $result;
    }
}