<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Admin
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Admin
 * @subpackage  Model
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Admin_Model_User extends Ecart_Db_Table 
{
    /**
     * The default table name 
     */
    protected $_name = 'admin_user';
    
    public function getRole($id)
    {
        return $this->getAdapter()->fetchOne("SELECT role_id FROM {$this->_name} WHERE id = ?", $id);
        // return $this->getRoleId($id);
    }
      
    public function getCount()
    {
        return parent::count(null, 'COUNT(id)');
    }
    
    public function getExist(array $ids = array()) 
    {
        $where = count($ids) ? ' WHERE ' . $this->getAdapter()->quoteInto('id IN(?)', $ids) : ''; 
        return $this->getAdapter()->fetchCol("SELECT id FROM {$this->_name} $where");   
    }
    
    public function update(array $data, $where)
    {
        if (empty($data['modified'])) {
            $data['modified'] = Ecart_Date::now()->toZendDbExpr();
        }
        return parent::update($data, $where);
    }
    
    public function insert(array $data)
    {
        if (empty($data['created'])) {
            $data['created'] = Ecart_Date::now()->toZendDbExpr();
        }
        return parent::insert($data);
    }
}
