<?php
/**
 * Ecart
 *
 * This file is part of Ecart.
 *
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Admin
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Admin
 * @subpackage  Controller
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Admin_CacheController extends Ecart_Admin_Controller_Back
{
    public function indexAction()
    {
        $this->view->pageTitle = Ecart::translate('admin')->__(
            'Cache management'
        );
        $this->render();
    }
    
    public function getListAction()
    {
        return $this->_helper->json->sendSuccess(array(
            'data' => Ecart::single('core/cache')->getList()
        ));
    }
    
    public function saveAction()
    {
        $data = Zend_Json_Decoder::decode($this->_getParam('data'));
        
        return $this->_helper->json->sendJson(array(
            'success' => Ecart::single('core/cache')->save($data)
        ));
    }
    
    public function cleanAction()
    {
        $tags = Zend_Json_Decoder::decode($this->_getParam('data'));

        Ecart::message()->addSuccess(
            Ecart::translate('admin')->__(
                'Cache was cleared successfully'
            )
        );
        return $this->_helper->json->sendJson(array(
            'success' => Ecart_Core_Model_Cache::getCache()->clean('matchingAnyTag', $tags)
        ));
    }
    
    public function cleanAllAction()
    {
        Ecart::message()->addSuccess(
            Ecart::translate('admin')->__(
                'Cache was cleared successfully'
            )
        );
        return $this->_helper->json->sendJson(array(
            'success' => Ecart_Core_Model_Cache::getCache()->clean()
        ));
    }
}