<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Admin
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Admin
 * @subpackage  Controller
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Admin_ErrorController extends Ecart_Admin_Controller_Back
{
    public function errorAction()
    {
        $errors = $this->_getParam('error_handler');
        $exception = $errors->exception;
        
        try {
            $log = new Zend_Log(new Zend_Log_Writer_Stream(Ecart::config()->system->path . Ecart::config()->log->main->php));
            $log->debug($exception->getMessage() . "\n" .  $exception->getTraceAsString());
        } catch (Zend_Log_Exception $e) {
            //who cares
        }
        
        $this->getResponse()->clearBody();
        
        if ($this->getRequest()->isXmlHttpRequest()) {
            Ecart::message()->addError($exception->getMessage());
            $this->_helper->json->sendFailure();
        } else {
            $this->view->pageTitle = Ecart::translate('admin')->__('Error');
            $this->view->error = str_replace("\n", "<br />\n", $exception->getMessage() . "\n" 
             . $exception->getTraceAsString());
            $this->render();
        }
    }
}