<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Catalog
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Catalog
 * @subpackage  Box
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Catalog_Box_Navigation extends Ecart_Core_Box_Abstract
{
    protected $_title = 'Categories';
    protected $_class = 'box-category';
    
    public function init()
    {
        $tree = Ecart::single('catalog/category')->cache()
            ->getFlatTree(Ecart::getLanguageId(), Ecart::getSiteId(), true);
        
        if (!current($tree) || !count(current($tree))) {
            return false;
        }
        $this->setData('items', current($tree));
    }
    
    public function hasContent()
    {
        return true;//$this->hasData('items');
    }
}