<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Catalog
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Catalog
 * @subpackage  Box
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Catalog_Box_Popular extends Ecart_Catalog_Box_Product_Listing
{
    protected $_title = 'Popular';
    protected $_class = 'box-popular';
    
    public function initData()
    {
        $params = array(
            'siteId' => Ecart::getSiteId() , 
            'currentDate' => Ecart_Date::now()->toPhpFormat()->toString('Y-m-d'),
            'categoryId' => Ecart_HumanUri::getInstance()->getParamValue('cat'), 
            'limit' => $this->getProductsCount()
        );
        
        $productIds = Ecart::single('catalog/product')
            ->getPopularProductIds($params);
        
        if (!count($productIds)) {
            return false;
        }

        $this->products = Ecart::single('catalog/product')->cache()
            ->getProductListByIds($productIds);
    }
}