<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Catalog
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Catalog
 * @subpackage  Model
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Catalog_Model_Product_Option_Row extends Ecart_Db_Table_Row
{
    public function getValuesArrayByLanguage($languageId)
    {
        $select = $this->getAdapter()->select();
        $select->from(array('pov' => self::$_db_prefix . 'catalog_product_option_value'))
            ->join(
                array('povt' => self::$_db_prefix . 'catalog_product_option_value_text'),
                'pov.id = povt.product_option_value_id',
                'name'
            )
            ->where('pov.valueset_id = ' . $this->valueset_id)
            ->where('povt.language_id = ' . $languageId);
        return $select->query()->fetchAll();
    }
    
    public function isInputable()
    {
        if ($this->option_type == Ecart_Catalog_Model_Product_Option::TYPE_STRING || 
            $this->option_type == Ecart_Catalog_Model_Product_Option::TYPE_TEXTAREA || 
            $this->option_type == Ecart_Catalog_Model_Product_Option::TYPE_FILE)
            return true;
        return false;
    }
    
    public function getValueset()
    {
        if ($this->valueset_id)
            return $this->findParentRow('Ecart_Catalog_Model_Product_Option_ValueSet', 'ValueSet');
        return null;
    }
}