<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Cms
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Cms
 * @subpackage  Box
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Cms_Box_Navigation extends Ecart_Core_Box_Abstract
{
    protected $_title = 'Pages';
    protected $_class = 'box-cms-page';
    
    public function init()
    {
        $categories = Ecart::single('cms/category')->getRootCategories();
        $pages = Ecart::single('cms/page')->getBoxPages();
        if (!count($categories) && !count($pages)) {
            return false;
        }
        $this->updateData(array(
            'categories' => $categories,
            'pages' => $pages
        ));
    }
    
    public function hasContent()
    {
        return $this->hasCategories() || $this->hasPages();
    }
}