<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Cms
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Cms
 * @subpackage  Model
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Cms_Model_Category_Row extends Ecart_Db_Table_Row  
{
    public function getContent()
    {
        $langId = Ecart::getLanguageId();
        
        /*get category title & description*/
        $contentQuery = "SELECT ccc.title, ccc.description,
                                ccc.meta_keyword, ccc.meta_description, ccc.meta_title
                         FROM   " . self::$_db_prefix . "cms_category_content as ccc
                         WHERE  ccc.cms_category_id = $this->id
                         AND    ccc.language_id = $langId";

        $catContent = $this->getAdapter()->fetchRow($contentQuery);              
        
        /*get childs categories*/
        $childQuery = "SELECT ccc.link, ccc.title
                       FROM   " . self::$_db_prefix . "cms_category_content as ccc, " . 
                                  self::$_db_prefix . "cms_category as cc
                       WHERE  cc.parent_id = $this->id
                       AND    ccc.language_id = $langId
                       AND    ccc.link IS NOT NULL
                       AND    ccc.cms_category_id = cc.id
                       AND    cc.is_active = 1";
                        
        $catChilds = $this->getAdapter()->fetchAll($childQuery);

        /*get pages*/
        $pageQuery = "SELECT cpc.link, cpc.title
                      FROM   " . self::$_db_prefix . "cms_page_content as cpc, " . 
                                 self::$_db_prefix . "cms_page_category as cptc
                      WHERE  cptc.cms_category_id = $this->id
                      AND    cpc.language_id = $langId
                      AND    cpc.link IS NOT NULL
                      AND    cpc.cms_page_id = cptc.cms_page_id";
                      
        $catPages = $this->getAdapter()->fetchAll($pageQuery);
                      
        return array(
            'content' => $catContent,
            'childs' => $catChilds,
            'pages' => $catPages
        );
    }
}