<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Cms
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Cms
 * @subpackage  Controller
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Cms_IndexController extends Ecart_Core_Controller_Front 
{
    public function indexAction()
    {
        $this->view->pageTitle = Ecart::translate('cms')->__('Pages');
        
        $categories = Ecart::single('cms/category')->cache()->getActiveCategory();
        
        $categoriesIds = array ();
        foreach ($categories as $category) {
             $categoriesIds[] = $category['id'];
        }
        $rowset = Ecart::single('cms/page')->cache()->getPageListByActiveCategory(
            $categoriesIds, Ecart::getLanguageId()
        )      ;
        $pages = array();
        foreach ($rowset as $page) {
            $pages[$page['cms_category_id']][] = $page; 
        }
        $result = array();
        foreach ($categories as $category) {
            $result[intval($category['parent_id'])][$category['id']] = array(
                'id' => $category['id'],
                'title' => $category['title'],
                'link' => $category['link'],
                'pages' => isset($pages[$category['id']]) ?
                    $pages[$category['id']] : null
            );
        }
        $this->view->tree = $result;
        $this->render();
    }
}