<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Csv
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */
 
/**
 * @var Ecart_Install_Model_Installer
 */
$installer = Ecart::single('install/installer');

$installer->startSetup();

$installer->run("

-- DROP TABLE IF EXISTS `{$installer->getTable('csv_profile')}`;
CREATE TABLE  `{$installer->getTable('csv_profile')}` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(128) NOT NULL,
  `type` varchar(32) NOT NULL,
  `direction` enum('export','import') NOT NULL,
  `site` varchar(20) NOT NULL,
  `file_path` varchar(255) NOT NULL,
  `file_name` varchar(90) NOT NULL,
  `created_at` datetime NOT NULL,
  `updated_at` datetime NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- DROP TABLE IF EXISTS `{$installer->getTable('csv_profile_filter')}`;
CREATE TABLE  `{$installer->getTable('csv_profile_filter')}` (
  `profile_id` int(10) unsigned NOT NULL,
  `language_ids` varchar(128) NOT NULL,
  `product_name` varchar(128) NOT NULL,
  `product_sku` varchar(128) NOT NULL,
  `stock` tinyint(3) unsigned NOT NULL default '2',
  `status` tinyint(3) unsigned NOT NULL default '2',
  `price_from` int(10) unsigned default NULL,
  `price_to` int(10) unsigned default NULL,
  `qty_from` int(10) unsigned default NULL,
  `qty_to` int(10) unsigned default NULL,
  PRIMARY KEY  (`profile_id`),
  CONSTRAINT `FK_csv_profile_filter_id` FOREIGN KEY (`profile_id`) REFERENCES `{$installer->getTable('csv_profile')}` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

");

Ecart::single('admin/menu')
    ->add('Administrate', '#', 110)
    ->add('Administrate->Import/Export', '#', 70)
    ->add('Administrate->Import/Export->csv Import/Export', 'csv', 10);
    
Ecart::single('admin/acl_resource')
    ->add('admin/csv', 'Import/Export')
    ->add("admin/csv/delete")
    ->add("admin/csv/get-list")
    ->add("admin/csv/get-supported-types")
    ->add("admin/csv/index")
    ->add("admin/csv/run")
    ->add("admin/csv/save");
    
$installer->registerModule('Ecart_Csv');

$installer->endSetup();