<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Install
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Install
 * @subpackage  Model
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Install_Model_Locale
{
    const DEFAULT_LOCALE = 'en_US';
    
    /**
     * @static
     * @return array
     */
    public static function getLocaleList()
    {
        $options    = array();
        
        $locales = Zend_Locale::getLocaleList();
        $languages  = Zend_Locale::getTranslationList('language', self::DEFAULT_LOCALE);
        $countries  = Zend_Locale::getTranslationList('territory', self::DEFAULT_LOCALE, 2);
        
        
        foreach ($locales as $code => $is_active) {
            if (strstr($code, '_')) {
                $data = explode('_', $code);
                if (!isset($languages[$data[0]]) || !isset($countries[$data[1]])) {
                    continue;
                }
                $options[$code] = ucfirst($languages[$data[0]]) . ' (' . $countries[$data[1]] . ')';
            }
        }
        return $options;
    }
    
    /**
     * 
     * @static
     * @return array
     */
    public static function getTimeZoneList()
    {
        $options= array();
        $zones  = Zend_Locale::getTranslationList('WindowsToTimezone', self::DEFAULT_LOCALE);
        
        asort($zones);
        foreach ($zones as $code => $name) {
            $name = trim($name);
            $options[$code] =  empty($name) ? $code : $name . ' (' . $code . ')';
        }
        return $options;
    }
    
    /**
     * @static
     * @return array
     */
    public static function getCurrencyList()
    {
        return Zend_Locale::getTranslationList('NameToCurrency', self::DEFAULT_LOCALE);
        
    }
}