<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Locale
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Locale
 * @subpackage  Model
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Locale_Model_Language extends Ecart_Db_Table
{
    protected $_name = 'locale_language';
    protected $_rowClass = 'Ecart_Db_Table_Row';
    
    protected $_localeList = null;
    
    public function getCodeLanguages()
    {
        $languages = $this->getAdapter()->fetchAll(
            "SELECT locale, language AS name FROM {$this->_name}"
        );
        $result = array();
        foreach ($languages as $language) {
            $result[$language['locale']] = $language['name'];
        }
        return $result;
    }
    
    public function getLocaleList()
    {
        if (null === $this->_localeList) {
            $this->_localeList = $this->getAdapter()->fetchCol("SELECT locale FROM {$this->_name}");
        }
        return $this->_localeList;
    }
}