<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Locale
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Locale
 * @subpackage  Controller
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Locale_IndexController extends Ecart_Core_Controller_Front
{   
    public function changeAction()
    {
        $locale = $this->_getParam('lang');
        $redirectUrl = $lastUrl = $_SERVER['HTTP_REFERER'];
        if ($locale) {
            $langUrl = Ecart_Locale::getLanguageUrl();
            $urlPrefix = $this->view->baseUrl . $langUrl;
            $redirectUrl = substr($lastUrl, strpos($lastUrl, $urlPrefix) + strlen($urlPrefix));
            Ecart_Locale::setLocale($locale);
        }
        $this->_redirect($redirectUrl);
    }
    
}