<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Location
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Location
 * @subpackage  Model
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Location_Model_Zone extends Ecart_Db_Table
{
    protected $_name = 'location_zone';

    /**
     *
     * @param array $data
     */
    public function save($data)
    {
        $db = $this->getAdapter();
        
        $ids = array_keys($data);
        $where = $db->quoteInto('id IN (?)', $ids);
        $exists = $db->fetchCol("SELECT id FROM {$this->_name} WHERE $where");
        
        foreach ($data as $id => $values) {
            if (empty($values['code']) || empty($values['name']))
                continue;
            
            $row = array(
                'code' => $values['code'],
                'name' => $values['name'],
                'country_id' => $values['country_id']
            );
            
            if (in_array($id, $exists)) {
                $this->update($row, $db->quoteInto('id = ?', $id));
            } else {
                $this->insert($row);
            }
        }
    }

    /**
     *
     * @param string $code
     * @return array
     */
    public function getByCode($code)
    {
        return $this->getAdapter()->fetchRow(
            "SELECT * FROM " . $this->_name . ' WHERE code = ? ', $code
        );
    }
    
} 