<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Log
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * @var Ecart_Install_Model_Installer
 */
$installer = Ecart::single('install/installer');

$installer->startSetup();


/**
 * created tables:
 *  log_url,
 *  log_url_info,
 *  log_visitor,
 *  log_visitor_info
 */

$installer->run("

-- DROP TABLE IF EXISTS `{$installer->getTable('log_url')}`;
CREATE TABLE IF NOT EXISTS `{$installer->getTable('log_url')}` (
  `visit_at` datetime default NULL,
  `url_id` int(11) NOT NULL,
  `visitor_id` int(11) NOT NULL,
  `site_id` smallint(9) NOT NULL,
  PRIMARY KEY  (`url_id`,`visitor_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- DROP TABLE IF EXISTS `{$installer->getTable('log_url_info')}`;
CREATE TABLE IF NOT EXISTS `{$installer->getTable('log_url_info')}` (
  `id` mediumint(7) NOT NULL auto_increment,
  `url` varchar(255) default NULL,
  `refer` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

-- DROP TABLE IF EXISTS `{$installer->getTable('log_visitor')}`;
CREATE TABLE IF NOT EXISTS `{$installer->getTable('log_visitor')}` (
  `id` mediumint(7) unsigned NOT NULL auto_increment,
  `session_id` char(32) default NULL,
  `customer_id` int(11) default NULL,
  `last_url_id` int(11) default NULL,
  `last_visit_at` datetime default NULL,
  `site_id` smallint(9) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

-- DROP TABLE IF EXISTS `{$installer->getTable('log_visitor_info')}`;
CREATE TABLE IF NOT EXISTS `{$installer->getTable('log_visitor_info')}` (
  `visitor_id` int(11) NOT NULL,
  `http_refer` varchar(255) default NULL,
  `user_agent` varchar(255) default NULL,
  `http_accept_charset` varchar(128) default NULL,
  `http_accept_language` varchar(128) default NULL,
  `server_addr` varchar(128) default NULL,
  `remote_addr` varchar(128) default NULL,
  PRIMARY KEY  (`visitor_id`),
  KEY `fk_log_visitor_info_log_visitor` (`visitor_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

");

Ecart::single('core/config_field')
    ->add('log/main/enabled', 'Logging/Main/Enabled', 1, 'bool')
    ->add('log/main/php', 'php log', '/var/logs/php.log', 'string', 'Path relative to ECART_ROOT')
    ->add('log/main/payment', 'Payment log', '/var/logs/payment.log', 'string', 'Path relative to ECART_ROOT')
    ->add('log/main/shipping', 'Shipping log', '/var/logs/shipping.log', 'string', 'Path relative to ECART_ROOT');

Ecart::single('admin/menu')
    ->add('Catalog', '#', 20)
    ->add('Catalog->Reports', '#', 60)
    ->add('Catalog->Reports->Pageviews', 'log', 20);
    
Ecart::single('admin/acl_resource')
    ->add('admin/log', 'Log Pageviws')
    ->add("admin/log/index")
    ->add("admin/log/list");
    
Ecart::single('core/page')
    ->add('account/*/*');

$installer->registerModule('Ecart_Log');

$installer->endSetup();