<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_PaymentCashOnDelivery
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */
 
/**
 * @var Ecart_Install_Model_Installer
 */
$installer = Ecart::single('install/installer');

$installer->startSetup();

Ecart::single('core/config_field')
    ->add('payment/CashOnDelivery_Standart/enabled', 'Payment Methods/Cash On Delivery/Enabled', 1, 'bool', 'Do you want to accept Cash On Delivery payments?')
    ->add('payment/CashOnDelivery_Standart/title', 'Title', 'Cash On Delivery', 'string', 'Title')
    ->add('payment/CashOnDelivery_Standart/geozone', 'Allowed Payment Zone', '1', 'select', 'If a zone is selected, only enable this payment method for that zone.', array('model' => 'Geozone'))
    ->add('payment/CashOnDelivery_Standart/sortOrder', 'Sort Order', '1', 'string', 'Sort Order Lowest is displayed first.')
    ->add('payment/CashOnDelivery_Standart/orderStatusId', 'Order Status on payment complete', '1', 'select', 'Set the status of orders made with this payment module to this value', /*array('model' => 'OrderStatus')*/array('config_options' => '{"1":"pending"}'))
    ->add('payment/CashOnDelivery_Standart/shippings', 'Allowed Shippings', '0', 'multiple', 'If a shippings method is selected, only enable this shipping method for that shippings.', array('model' => 'Shipping'))
    //->add('payment/CashOnDelivery_Standart/costs', 'Costs for inland shipping', '0', 'string', 'Costs')
    //->add('payment/CashOnDelivery_Standart/costsForeign', 'Costs for shipping to foreign countries', '', 'string', 'Costs')
    ;

$installer->registerModule('Ecart_PaymentCashOnDelivery');

$installer->endSetup();