<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_PaymentCreditCard
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * @var Ecart_Install_Model_Installer
 */
$installer = Ecart::single('install/installer');

$installer->startSetup();

Ecart::single('core/config_field')
    ->add('payment/CreditCard_Standart/title', 'Payment Methods/Save Credit Card/Title', 'Save Credit Card', 'string', 'Title')
    ->add('payment/CreditCard_Standart/enabled', 'Enabled', 0, 'bool', 'Do you want to accept credit card order payments?')
    ->add('payment/CreditCard_Standart/geozone', 'Payment zone', '1', 'select', 'If a zone is selected, only enable this payment method for that zone.', array('model' => 'Geozone'))
    ->add('payment/CreditCard_Standart/sortOrder', 'Sort Order', '1', 'string',  'Sort Order Lowest is displayed first.')
    ->add('payment/CreditCard_Standart/orderStatusId', 'Order Status on payment complete', '1', 'select', 'Set the status of orders made with this payment module to this value', /*array('model' => 'OrderStatus')*/array('config_options' => '{"1":"pending"}'))
    ->add('payment/CreditCard_Standart/enabledCvv', 'Accept verification code', '1', 'bool', 'Do you want validate cvv on Credit Card Order payments?')
    ->add('payment/CreditCard_Standart/saveCvv', 'Save verification code', '0', 'bool', 'Do you want save cvv on Credit Card Order payments?')
    ->add('payment/CreditCard_Standart/minOrderTotal', 'Minimum order total amount', '', 'string', 'Minimum Order Total')
    ->add('payment/CreditCard_Standart/maxOrderTotal', 'Maximum order total amount', '', 'string', 'Maximum Order Total')
    ->add('payment/CreditCard_Standart/creditCard', 'Accepted credit cards', 'Visa', 'multiple', 'Types credit cards used in this payment', array('model' => 'CreditCard'))
    ->add('payment/CreditCard_Standart/saveCCAction', 'Save credit card number action', 'last_four', 'select', 'How would you like to save credit card number', array('model' => 'CreditCard_SaveNumberAction'))
    ->add('payment/CreditCard_Standart/shippings', 'Allowed Shippings', '0', 'multiple', 'If a shippings method is selected, only enable this shipping method for that shippings.', array('model' => 'Shipping'));

$installer->registerModule('Ecart_PaymentCreditCard');

$installer->endSetup();