<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_PaymentPaypal
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_PaymentPaypal
 * @subpackage  Controller
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_PaymentPaypal_StandartController extends Ecart_Core_Controller_Front_Secure
{
    
    /**
     * customer cancel payment from paypal
     */
    public function cancelAction()
    {
        if (!$customerId = Ecart::getCustomerId()) {
            return;
        }
        $orderId = $this->_getParam('invoice');
        if (!$orderId) {
            return;
        }
        $order = Ecart::single('sales/order')->find($orderId)->current();
        if (!$order instanceof Ecart_Sales_Model_Order_Row) {
            return;
        }
        if ($customerId != $order->customer_id) {
            return;
        }
        $order->setStatus('cancel', 'Canceled on paypal');
        $this->_redirect('/checkout/cancel');
    }
    
    /**
     * when paypal returns
     * The order information at this point is in POST
     * variables.  However, you don't want to "process" the order until you
     * get validation from the IPN. 
     */
    public function successAction()
    {
        //error_log(Zend_Debug::dump($this->_getAllParams()));
        // @todo create for this module table with addational information of transaction
        // and on admin need render payer_email in order view
        $this->_redirect('/checkout/success');
    }
    
    /**
     * when paypal returns via ipn
     * cannot have any output here
     * validate IPN data
     * if data is valid need to update the database that the user has
     */
    public function ipnAction() 
    {
        Ecart::single('PaymentPaypal/Standart')->ipnSubmit($this->_getAllParams());    
    }
}