<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Poll
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Poll
 * @subpackage  Model
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Poll_Model_Vote extends Ecart_Db_Table
{
    protected $_name = 'poll_vote';
    
    public function isVoted($questionId, $ip = null)
    {
        if (null === $ip)
            $ip = ip2long($_SERVER['REMOTE_ADDR']);
    	$query = "SELECT  count(*) FROM {$this->_name} as  pv " .  
            'INNER JOIN ' . self::$_db_prefix . 'poll_answer pa ON pa.id = pv.answer_id ' .
            "WHERE   pa.question_id = ? AND pv.ip = ? ";
        return $this->getAdapter()->fetchOne($query, array($questionId, $ip));
    }
    
    public function getVoteCount()
    {
        $rows =  $this->getAdapter()->fetchAll(
        	"SELECT q.id, count(v.id) as cnt  FROM " . self::$_db_prefix . "poll_question q
            LEFT JOIN " . self::$_db_prefix . "poll_answer AS a ON a.question_id = q.id
            LEFT JOIN {$this->_name} AS v ON v.answer_id = a.id
            GROUP BY q.id "
        );
        $assigns = array();
        foreach ($rows as $row) {
            $assigns[$row['id']] = $row['cnt'];
        }
        return $assigns;
    }
}