<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Sales
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Sales
 * @subpackage  Model
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Sales_Model_Order_Total extends Ecart_Db_Table
{
    protected $_name = 'sales_order_total';
    
    public function getShipping($orderId) {
        $query = "SELECT value FROM " . $this->_name  . " WHERE order_id = ? AND title = 'Shipping'";
        return $this->getAdapter()->fetchOne($query, intval($orderId));
    }
    
    public function getTax($orderId) {
        $query = "SELECT value FROM " . $this->_name . " WHERE order_id = ?  AND title = 'Tax'"; 
        return $this->getAdapter()->fetchOne($query, intval($orderId));
    }
    
    public function getShippingTax($orderId) {
        $query = "SELECT value FROM " . $this->_name . " WHERE order_id = ?  AND title = 'Shipping Tax'"; 
        return $this->getAdapter()->fetchOne($query, intval($orderId));
    }
    
    public function getSubtotal($orderId) {
        $query = "SELECT value FROM " . $this->_name . " WHERE order_id = ?  AND title = 'Subtotal'"; 
        return $this->getAdapter()->fetchOne($query, intval($orderId));
    }
    //@todo merge "get" function on __get()
}