<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_ShippingFlat
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_ShippingFlat
 * @subpackage  Model
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_ShippingFlat_Model_Standart extends Ecart_Method_Shipping_Model_Abstract
{
    protected $_code = 'Flat_Standart';
    protected $_title = 'Flat Rate';
    protected $_description = 'Flat Rate';
    private $_geozone;
    private $_taxClass;
    private $_taxBasic;
    
    public function __construct($type = null)
    {
        parent::__construct($type);
        $this->_icon = $this->_config->icon;
    }
    
    public function getTypes($request)
    {
        if (!$this->_config->multiPrice) {
            return array();
        }
        foreach ($this->_config->multiPrice->toArray() as $id => $item) {
            $price = $item['price'];
            if ($this->_config->type === 'Per Item') {
                $price = $request['qty'] * $price;
            }
            
            $this->_types[] = array(
                'id' => $this->_code . '_' . $id,
                'title' => $this->getTranslator()->__($item['title']),
                'price' => $price
            );
        }
        return $this->_types;
    }
}