<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_ShippingItem
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_ShippingItem
 * @subpackage  Model
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_ShippingItem_Model_Standart extends Ecart_Method_Shipping_Model_Abstract
{
    protected $_code = 'Item_Standart';
    protected $_title = 'Item';
    protected $_description = 'Shipping, Item, description';
    
    public function __construct($type = null)
    {
        parent::__construct($type);
        $this->_icon = $this->_config->icon;
    }
    
    public function getTypes($request)
    {
        $method = array(
            'id' => $this->_code,
            'title' => $this->getTitle(),
            'price' => (is_numeric($this->_config->price) ? 
                floatval($this->_config->price) : 0) * $request['qty']
        );
        
        if ($this->_icon) {
            $method['icon'] = $this->getIcon();
        }
        $this->_types[] = $method;
        return $this->_types;
    }
}