<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_ShippingUps
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */
 
/**
 * @var Ecart_Install_Model_Installer
 */
$installer = Ecart::single('install/installer');

$installer->startSetup();

Ecart::single('core/config_field')
    ->add('shipping/Ups_Standart/enabled', 'Shipping Methods/Ups Standart/Enabled', '0', 'bool', 'Do you want to use this shippings method(s)?')
    ->add('shipping/Ups_Standart/geozone', 'Shipping Zone', '1', 'select', 'If a zone is selected, only enable this shipping method for that zone.', array('model' => 'Geozone'))
    ->add('shipping/Ups_Standart/taxBasis', 'Tax Basis', 'None', 'select', 'On what basis is Shipping Tax calculated. Options are.Shipping - Based on customers Shipping AddressBilling Based on customers Billing addressStore - Based on Store address if Billing/Shipping Zone equals Store zone', array('model' => 'TaxBasis'))
    ->add('shipping/Ups_Standart/taxClass', 'Tax Class', '', 'select', 'Used for this shipping method(s) tax class', array('model' => 'TaxClass'))
    ->add('shipping/Ups_Standart/sortOrder', 'Sort Order', '0')
    ->add('shipping/Ups_Standart/pickup', 'UPS Pickup Method', 'CC', 'select', 'How do you give packages to UPS? CC - Customer Counter, RDP - Daily Pickup, OTP - One Time Pickup, LC - Letter Center, OCA - On Call Air', array('config_options' => 'CC,RDP,OTP,LC,OCA'))
    ->add('shipping/Ups_Standart/package', 'UPS Packaging?', 'CP', 'select', 'CP - Your Packaging, ULE - UPS Letter, UT - UPS Tube, UBE - UPS Express Box', array('config_options' => 'CP,ULE,UT,UBE'))
    ->add('shipping/Ups_Standart/res', 'Residential Delivery?', 'RES', 'select', 'Quote for Residential (RES) or Commercial Delivery (COM)', array('config_options' => 'RES,COM'))
    ->add('shipping/Ups_Standart/handling', 'Handling Fee', '0', 'string', 'Handling fee for this shipping method.')
    ->add('shipping/Ups_Standart/title', 'Title', 'Ups')
    ->add('shipping/Ups_Standart/types', 'Allowed Shipping Methods', 
        '1DM,1DML,1DA,1DAL,1DAPI,1DP,1DPL,2DM,2DML,2DA,2DAL,3DS,GND,GNDCOM,GNDRES,STD,XPR,WXS,XPRL,XDM,XDML,XPD',
        'multiple', 'Select the UPS services to be offered. : <br />Nxt AM, Nxt AM Ltr, Nxt, Nxt Ltr, Nxt PR, Nxt Save, Nxt Save Ltr, 2nd AM, 2nd AM Ltr, 2nd, 2nd Ltr, 3 Day Select, Ground, Canada,World Xp, World Xp Ltr, World Xp Plus, World Xp Plus Ltr, World Expedite, WorldWideSaver.',
        array('config_options' => '1DM,1DML,1DA,1DAL,1DAPI,1DP,1DPL,2DM,2DML,2DA,2DAL,3DS,GND,GNDCOM,GNDRES,STD,XPR,WXS,XPRL,XDM,XDML,XPD')

    )
    ->add('shipping/Ups_Standart/boxWeightDisplay', 'Shipping/Default/boxWeightDisplay', '1', 'string', 'Variants: 0, 1 or 2 ')
    ->add('shipping/Ups_Standart/type', 'UPS Type', 'CGI', 'select', 'CGI or XML', array('config_options' => 'CGI,XML'))
    ->add('shipping/Ups_Standart/measure', 'UPS Weight Unit', 'LBS', 'select', 'LBS or KGS', array('config_options' => 'LBS,KGS'))
    ->add('shipping/Ups_Standart/payments', 'Allowed Payments', '0', 'multiple', 'If a payment method is selected, only enable this shipping method for that payments.', array('model' => 'Payment'))
    ->add('shipping/Ups_Standart/gateway', 'Gateway Url', 'http://www.ups.com/using/services/rave/qcostcgi.cgi')

    ->add('shipping/Ups_Standart/xmlUserId', 'XML Account User Id', '', 'handler', '', array('model' => 'Crypt'))
    ->add('shipping/Ups_Standart/xmlPassword', 'XML Account Password', '', 'handler', '', array('model' => 'Crypt'))
    ->add('shipping/Ups_Standart/xmlAccessLicenseNumber', 'XML Access License Number', '', 'handler', '', array('model' => 'Crypt'))
    ->add('shipping/Ups_Standart/xmlGateway', 'Gateway XML URL', 'https://onlinetools.ups.com/ups.app/xml/Rate')
    ->add('shipping/Ups_Standart/xmlOrigin', 'Origin of the shipment', 'Shipments Originating in United States', 'select', '', array('config_options' => 'United States Domestic Shipments,Shipments Originating in United States,Shipments Originating in Canada,Shipments Originating in the European Union,Polish Domestic Shipments,Puerto Rico Origin,Shipments Originating in Mexico,Shipments Originating in Other Countries'))
    ->add('shipping/Ups_Standart/negotiatedActive', 'Enable Negotiated Rates', '0', 'bool')
    ->add('shipping/Ups_Standart/shipperNumber', 'Shipper Number', '', 'handler', '', array('model' => 'Crypt'))
    ;
    
$installer->registerModule('Ecart_ShippingUps');

$installer->endSetup();