<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Sitemap
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * @var Ecart_Install_Model_Installer
 */
$installer = Ecart::single('install/installer');

$installer->startSetup();

/**
 * drop tables: 
 *  sitemap_engine,
 *  sitemap_file
 *  sitemap_file_engine
 */
$installer->run("

DROP TABLE IF EXISTS `{$installer->getTable('sitemap_file')}`;

DROP TABLE IF EXISTS `{$installer->getTable('sitemap_file_engine')}`;

");

Ecart::single('core/config_field')->remove('sitemap');
Ecart::single('core/config_value')->remove('sitemap');

Ecart::single('admin/menu')->remove('CMS->Sitemap');

Ecart::single('admin/acl_resource')->remove('admin/sitemap');

Ecart::single('core/page')->remove('sitemap/*/*')
    ->remove('sitemap/index/*')
    ->remove('sitemap/index/index')
    ->remove('sitemap/index/get-all-categories')
    ->remove('sitemap/index/get-all-products')
    ->remove('sitemap/index/get-all-pages');

$installer->unregisterModule('Ecart_Sitemap');

$installer->endSetup();