<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Tag
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Tag
 * @subpackage  Model
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Tag_Model_Product extends Ecart_Db_Table
{
    protected $_name = 'tag_product';
    protected $_referenceMap    = array(
        'Tag' => array(
            'columns'         => 'customer_tag_id',
            'refTableClass' => 'Ecart_Tag_Model_Customer',
            'refColumns'    => 'id',
            'onDelete'        => self::CASCADE
        )
    );
    /**
     *
     * @param int $tagId
     * @return int
     */
    public function weightTag($tagId){
       return $this->getAdapter()->fetchOne('SELECT COUNT(*) FROM '
           . $this->_name . ' WHERE customer_tag_id = ' . intval($tagId)
       );
    }

    /**
     *
     * @param $tagItemId
     * @return mixed
     */
    public function deleteMy($tagItemId)
    {
        $row = $this->find($tagItemId)->current();
        if (!$row) {
            return false;
        }
        $parentRow = $row->findParentRow('Ecart_Tag_Model_Customer');

        if ($parentRow->customer_id != Ecart::getCustomerId() ||
            $parentRow->site_id != Ecart::getSiteId()) {
            return false;
        }
        return $row->delete();
    }
}