<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 *
 * @category    Ecart
 * @package     Ecart_Install
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 *
 * @category    Ecart
 * @package     Ecart_Install
 * @subpackage  Helper
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_View_Helper_Progress
{
    /**
     *
     * @return string
     */
    public function progress()
    {
        $install = Ecart_Install_Model_Wizard::getInstance();
        $steps = $install->getSteps();
        $current = $install->getCurrent();
        
        $html = '<ul class=\'install-progress\'>';
        foreach ($steps as $id => $step) {
            if ($current == $id)
                $html .= '<li class="active">' . $this->view->t($step) . '</li>';
            else
                $html .= '<li>' . $this->view->t($step) . '</li>';
        }
        $html .= '</ul>';
        
        return $html;
    }
    
    public function setView($view)
    {
        $this->view = $view;
    }
}