/**
 * Ecart
 *
 * This file is part of Ecart.
 *
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 */

Ext.onReady(function(){
    
    Ext.form.Field.prototype.msgTarget = 'qtip';
    
    categoryForm = new Ext.form.FormPanel({
        id: 'categoryForm',
        labelWidth: 80,
        autoScroll: true,
        border: false,
        labelAlign: 'left',
        reader: new Ext.data.JsonReader({},
            categoryReader
        ),
        items: [{
            layout: 'column',
            border: false,
            bodyStyle: 'padding: 10px 10px 0px',
            items: [{
                columnWidth: .5,
                layout: 'form',
                labelWidth: 40,
                border: false,
                items: [{
                    fieldLabel: 'Status'.l(),
                    xtype: 'combo',
                    store: new Ext.data.SimpleStore({
                        fields: ['id', 'value'],
                        data: [['enabled', 'Enabled'.l()], ['disabled', 'Disabled'.l()]]
                    }),
                    displayField: 'value',
                    valueField: 'id',
                    mode: 'local',
                    emptyText: 'Select status'.l(),
                    value: 'enabled',
                    triggerAction: 'all',
                    editable: false,
                    hiddenName: 'catStatus',
                    name: 'catStatus',
                    anchor: '95%'
                }]
           }, {
                columnWidth: .5,
                layout: 'form',
                labelWidth: 40,
                border: false,
                items: [{
                    fieldLabel: 'Url'.l(),
                    maxLength: 128,
                    allowBlank: false,
                    xtype: 'textfield',
                    allowBlank: false,
                    name: 'catKeyWord',
                    anchor: '95%'
                }]
            }]
        }, {         
            xtype: 'tabpanel',
            layoutOnTabChange: true,
            deferredRender: false,
            autoHeight: true,
            border: false,
            activeTab: 0,
            plain:true,
            defaults:{autoHeight:true, bodyStyle:'padding:10px'}, 
            items: languageTabs
        }, {
            xtype: 'hidden',
            name: 'catId',
            id: 'catId',
            value: 0
        }, {
            xtype: 'hidden',
            name: 'pId',
            id: 'pId',
            value: 0
        }]
    })
    
    categoryWin = new Ext.Window({
        id: 'categoryWindow',
        layout: 'fit',
        width: 620,
        height: 490,
        constrainHeader: true,
        bodyStyle:'background: white;',
        title: 'Category'.l(),
        closeAction: 'hide',
        items: categoryForm,
        buttons: [{
            text: 'Save'.l(),
            handler: Category.save
        },{
            text: 'Cancel'.l(),
            handler: function(){
                categoryWin.hide();
            }
        }]
    });
    
})
