/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

Ext.onReady(function (){
    var expander = new  Ext.grid.RowExpander({
        tpl : new Ext.Template(
            '<p><b>Attributes:</b> <div>{attributes}</div></p>'
        )
    });
    var storeShoppingCart = new Ext.data.Store({
        data: jsonDataProducts,
        reader: new Ext.data.JsonReader({
                root : 'products'
            },
            ['id','product_id','name','price','price_final','quantity','price_discount','attributes']
        )}
    ); 
    
    var columnsShoppingCart = new Ext.grid.ColumnModel([
        expander,
        {
             header: "Cart product Id".l(), 
             width: 145, 
             sortable: true, 
             dataIndex: 'id'
        },{
             header: "Product Id".l(), 
             width: 145, 
             sortable: true, 
             dataIndex: 'product_id'
        },{
             header: "Product Name".l(), 
             width: 145, 
             sortable: true,
             dataIndex: 'name' 
        },{
             header: "Price".l(), 
             width: 145, 
             renderer: 'usMoney',
             sortable: true,
             dataIndex: 'price'
        },{
            header: "Final Price".l(), 
            width: 145, 
            renderer: 'usMoney',
            sortable: true,
            dataIndex: 'price_final'
        },{
            header: "Quantity".l(), 
            width: 70, 
            sortable: true,
            dataIndex: 'quantity'
        },{
            header: "Discount".l(), 
            width: 130, 
            sortable: true,
            dataIndex: 'price_discount'
        }
        
    ]); 
       
    gridShoppingCart = new Ext.grid.GridPanel({
        title: storeShoppingCart.getTotalCount()+' item(s)', 
        store: storeShoppingCart,
        cm: columnsShoppingCart,
        stripeRows: true,
        height:550,
        bbar:[],
        plugins: [new Ext.ux.grid.Search({
            mode: 'local',
            iconCls: false,
            dateFormat: 'm/d/Y',
            minLength: 2,
               width: 170
        }), expander],
        renderTo: 'tab-shopping_cart-block',
        viewConfig: {
            forceFit: true,
            emptyText: 'No records found'.l()
        },
        width: 870
    });
        
     function editProduct()
     {
         var rowId = gridShoppingCart.getSelectionModel().getSelected().id; //get first selected row in grid
         var prodId = gridShoppingCart.getStore().getById(rowId).get('id');
         window.location =  Ecart.baseUrl + Ecart.adminUrl
                + '/catalog_index/index/siteId/.siteId./productId/.productId.'.replace(/\.siteId\./, siteId).replace(/\.productId\./, prodId);
     }
    gridShoppingCart.on('rowdblclick', editProduct);
});