/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

var action = {
    'product'  : Ecart.baseUrl + Ecart.adminUrl + '/catalog_index/index/siteId/.siteId./productId/.id.',
    'review'   : Ecart.baseUrl + Ecart.adminUrl + '/review_index/index/reviewId/.id.',
    'order'    : Ecart.baseUrl + Ecart.adminUrl + '/sales_order/index/orderId/.id.',
    'wishlist' : Ecart.baseUrl + Ecart.adminUrl + '/customer_wishlist/index/wishlistId/.id.',
    'customer' : Ecart.baseUrl + Ecart.adminUrl + '/customer_index/edit/customerId/.id.',
    'contact'  : Ecart.baseUrl + Ecart.adminUrl + '/contacts_index/index/mailId/.id.', //@todo it`s no work
    'search'   : Ecart.baseUrl + Ecart.adminUrl + '/search/index/searchId/.id.',
    
    'orderList'   :  Ecart.baseUrl + Ecart.adminUrl + '/sales_order/list',
    'contactList' :  Ecart.baseUrl + Ecart.adminUrl + '/contacts_index/list',
    'searchList'  :  Ecart.baseUrl + Ecart.adminUrl + '/search/list',
    'bestSeller'  :  Ecart.baseUrl + Ecart.adminUrl + '/catalog_index/list-bestseller',
    'listViewed'  :  Ecart.baseUrl + Ecart.adminUrl + '/catalog_index/list-viewed'
    
};
var params;
 Ext.onReady(function(){
    var quickSummary = new Ext.Panel({
        title: 'Quick Summary'.l(),
        collapsible:true,
        border: true,
        renderTo: 'quick-summary-dashboard',
        width:400,
        items:[
            {contentEl:'quick-summary-content', border: false}
        ]
    });
    var orderRecord = new Ext.data.Record.create([
        {name: 'id'},
        {name: 'site_id'},
        {name: 'date_purchased_on'},
        {name: 'billing_name'},
        {name: 'delivery_name'},
        {name: 'customer_email'},
        {name: 'customer_id'},
        {name: 'order_status_id'},
        {name: 'order_total'}
    ]);
      
    var dsOrder = new Ext.data.Store({
        proxy: new Ext.data.HttpProxy({
            method: 'post',
            url: action.orderList
        }),
        baseParams: params,
        reader: new Ext.data.JsonReader({
            root: 'data',
            totalProperty: 'count',
            id: 'id'
        }, orderRecord),

        remoteSort: true,
        pruneModifiedRecords: true
    });
    
    var dsOrderCustomer = new Ext.data.Store({
        proxy: new Ext.data.HttpProxy({
            method: 'post',
            url: action.orderList
        }),
        baseParams:params,
        reader: new Ext.data.JsonReader({
            root: 'data',
            totalProperty: 'count',
            id: 'id'
        }, orderRecord),

        remoteSort: true,
        pruneModifiedRecords: true
    });
    var cmOrder = new Ext.grid.ColumnModel([
        {
            header: "Customer".l(), 
            width: 170, 
            sortable: true,
            dataIndex: 'customer_email',
            renderer:   function (value, meta, record) {
            meta.attr = 'ext:qtip="Open in new window ' + value + '"';
            return String.format(
                    '<a href="{1}" class="grid-link-icon user" target="_blank" >{0}</a>',
                    value, action.customer.replace(/\.id\./, record.data.customer_id));
            } 
        },{
            header: "Purchased On".l(),
            dataIndex: 'date_purchased_on',
            width: 130
        },{
            header: "Order Total".l(),
            dataIndex: 'order_total',
            width: 130
        }
    ]);

    var ordersGrid = new Ext.grid.EditorGridPanel({
        ds: dsOrder,
        cm: cmOrder,
        border: false,
        viewConfig: {
            forceFit:true, 
            emptyText: 'No records found'.l()
        },
        autoHeight: true,
        width: 400,
        renderTo: 'orders-grid',
        bbar: new Ext.Toolbar({
            items:['->',
                new Ext.Button({
                    cls: 'x-btn-text',
                    text: 'All orders'.l(),
                    handler: function() { 
                        document.location.href =  Ecart.baseUrl + Ecart.adminUrl + '/sales_order/index/';
                    }
                })
            ]
        })
    });
    
    var ordersCustomerGrid = new Ext.grid.EditorGridPanel({
        ds: dsOrderCustomer,
        cm: cmOrder,
        border: false,
        viewConfig: {
            forceFit:true, 
            emptyText: 'No records found'.l()
        },
        autoHeight: true,
        width: 400,
        renderTo: 'customer-grid',
        bbar: new Ext.Toolbar({
            items:['->',
                new Ext.Button({
                    cls: 'x-btn-text',
                    text: 'All orders'.l(),
                    handler: function() { 
                        document.location.href =  Ecart.baseUrl + Ecart.adminUrl + '/sales_order/index/';
                    }
                })
            ]
        })
    });
    
    var dsContact = new Ext.data.Store({
        proxy: new Ext.data.HttpProxy({
            method: 'post',
            url: action.contactList 
        }),
        baseParams:params,
        reader: new Ext.data.JsonReader({
            root: 'data',
            totalProperty: 'count',
            id: 'id'
        }, Ext.data.Record.create([
            {name: 'id'},
            {name: 'email'},
            {name: 'subject'},
            {name: 'message'},
            {name: 'custom_info'},
            {name: 'department_name'},
            {name: 'created_at'},
            {name: 'department_id'},
            {name: 'datetime'},
            {name: 'message_status'}
        ])),

        remoteSort: true,
        pruneModifiedRecords: true
    });
    var cmContact = new Ext.grid.ColumnModel([
        {
            header: "Email".l(),
            dataIndex: 'email',
            width: 100,
            sortable: true
        },{
            header: "Subject".l(),
            dataIndex: 'subject',
            width: 100,
            sortable: true
        },{
            header: "Data & Time".l(),
            dataIndex: 'created_at',
            width: 170,
            sortable: true
        }
    ]);
    var contactGrid = new Ext.grid.EditorGridPanel({
        ds: dsContact,
        cm: cmContact,
        border: false,
        viewConfig: {
            forceFit:true, 
            emptyText: 'No records found'.l()
        },
        autoHeight: true,
        width: 400,
        renderTo: 'contact-grid',
        bbar: new Ext.Toolbar({
            items:['->',
                new Ext.Button({
                     cls: 'x-btn-text',
                    text: 'All contacts'.l(),
                    handler: function() { 
                        document.location.href =  Ecart.baseUrl + Ecart.adminUrl + '/contacts_index';
                    }
                })
            ]
        })
    });
    
    var dsSearch = new Ext.data.Store({
        proxy: new Ext.data.HttpProxy({
             method: 'post',
            url: action.searchList 
        }),
        baseParams: params,
        reader: new Ext.data.JsonReader({
            root: 'data',
            totalProperty: 'count',
            id: 'id'
        }, Ext.data.Record.create([
            {name: 'id'},
            {name: 'num_results'},
            {name: 'hit'},
            {name: 'session_id'},
            {name: 'created_at'},
            {name: 'query'},
            {name: 'customer_email'},
            {name: 'customer_id'}
        ])),

        remoteSort: true,
        pruneModifiedRecords: true
    });
    var cmSearch = new Ext.grid.ColumnModel([
        {
            header: "Query".l(), 
            width: 50,
            sortable: true, 
            dataIndex: 'query'
           
        },{
            header: "Results".l(), 
            id:'product_name',
            width: 45, 
            sortable: true,
            dataIndex: 'num_results'
        },{
            header: "Customer".l(), 
            width: 165, 
            sortable: true,
            dataIndex: 'customer_email',
            renderer: function (value, meta, record) {
                 var link = action.customer.replace(/\.id\./, record.data.customer_id);
                if (value == null) {
                    value = ' Guest';
                    link = '#';
                }
                meta.attr = 'ext:qtip="Open in new window ' + value + '"';
                return String.format(
                        '<a href="{1}" class="grid-link-icon user" target="_blank" >{0}</a>',
                        value, link);
            }
        },{
            header: "Hit".l(), 
            width: 25, 
            dataIndex: 'hit',
            sortable: true, 
            groupable:false
        },{
            header: "Created On".l(), 
            width: 130, 
            sortable: true,
            dataIndex: 'created_at',
            groupable:false
        }
        
    ]);
    var searchGrid = new Ext.grid.EditorGridPanel({
        ds: dsSearch,
        cm: cmSearch,
        border: false,
        viewConfig: {
            forceFit:true, 
            emptyText: 'No records found'.l()
        },
        autoHeight: true,
        width: 400, 
        renderTo: 'search-grid',
        bbar: new Ext.Toolbar({
            items:['->',
                new Ext.Button({
                    cls: 'x-btn-text',
                    text: 'All searches'.l(),
                    handler: function() { 
                        document.location.href =  Ecart.baseUrl + Ecart.adminUrl + '/search';
                    }
                })
            ]
        })
    });

    var dsBestView = new Ext.data.Store({
        proxy: new Ext.data.HttpProxy({
            method: 'post',
            url: action.listViewed 
        }),
        baseParams: params,
        reader: new Ext.data.JsonReader({
            root: 'data',
            totalProperty: 'count',
            id: 'id'
        }, Ext.data.Record.create([
            {name: 'id'},
            {name: 'viewed'},
            {name: 'price'},
            {name: 'product_name'}
        ])),
        remoteSort: true,
        pruneModifiedRecords: true
    });
   
    var cmBestView = new Ext.grid.ColumnModel([
        {
            header: "Product".l(), 
            width: 180,
            sortable: true, 
            dataIndex: 'product_name'
           
        },{
            header: "Price".l(), 
            width: 90, 
            sortable: true,
            dataIndex: 'price'
        },{
            header: "Viewed".l(), 
            width: 70, 
            sortable: true,
            dataIndex: 'viewed'
        }
        
    ]);
    var bestViewGrid = new Ext.grid.EditorGridPanel({
        ds: dsBestView,
        cm: cmBestView,
        border: false,
        autoHeight: true,
        width: 400,
        viewConfig: {
            forceFit:true, 
            emptyText: 'No records found'.l()
        },
        renderTo: 'bestview-grid'
    });
    
    var dsBestseller = new Ext.data.Store({
        proxy: new Ext.data.HttpProxy({
             method: 'post',
            url: action.bestSeller 
        }),
        baseParams:params,
        reader: new Ext.data.JsonReader({
            root: 'data',
            totalProperty: 'count',
            id: 'id'
        }, Ext.data.Record.create([
            {name: 'id'},
            {name: 'ordered_qty'},
            {name: 'ordered'},
            {name: 'price'},
            {name: 'product_name'}
        ])),

        remoteSort: true,
        pruneModifiedRecords: true
    });
    var cmBestseller = new Ext.grid.ColumnModel([
        {
            header: "Product".l(), 
            width: 180,
            sortable: true, 
            dataIndex: 'product_name'
           
        },{
            header: "Price".l(), 
            width: 90, 
            sortable: true,
            dataIndex: 'price'
        },{
            header: "Ordered Qty".l(), 
            width: 70, 
            dataIndex: 'ordered_qty'
        },{
            header: "Ordered".l(), 
            width: 70, 
            sortable: true,
            dataIndex: 'ordered'
        }
        
    ]);
    var bestsellerGrid = new Ext.grid.EditorGridPanel({
        ds: dsBestseller,
        cm: cmBestseller,
        border: false,
        autoHeight: true,
        width: 400,
        viewConfig: {
            forceFit:true, 
            emptyText: 'No records found'.l()
        },
        renderTo: 'bestseller-grid'
    });
    
    params = {
        'start' : 0,
        'limit' : 5,
        'dir'   : 'DESC',
        'sort'  : 'date_purchased_on'
    };
    if (onlyDate) {
        params['filter[0][data][comparison]'] = 'gt';
        params['filter[0][data][type]'] = 'date';
        params['filter[0][data][value]'] = date;
        params['filter[0][field]'] = 'date_purchased_on';
    }
    if (currentSiteId != 0 )
    {
        params['filter[1][data][type]']       = 'numeric';
        params['filter[1][data][comparison]'] = 'eq';
        params['filter[1][field]']            = 'site_id';
        params['filter[1][data][value]']      = currentSiteId;
    }
    ordersGrid.on('rowdblclick', function(grid, rowIndex, e) { 
        var row = ordersGrid.getStore().getAt(rowIndex);
        window.location = action.order.replace(/\.id\./, row.id);
    });
    ordersGrid.render();
    dsOrder.baseParams = params;
    dsOrder.load();
    
    params['filter[2][data][type]']       = 'numeric';
    params['filter[2][data][comparison]'] = 'noteq';
    params['filter[2][field]']            = 'customer_id';
    params['filter[2][data][value]']      = 0;
    ordersCustomerGrid.on('rowdblclick', function(grid, rowIndex, e) { 
        var row = ordersCustomerGrid.getStore().getAt(rowIndex);
        window.location = action.order.replace(/\.id\./, row.id);
    });
    ordersCustomerGrid.render();
    dsOrderCustomer.baseParams = params;
    dsOrderCustomer.load();
    
    delete params['filter[2][data][type]'];
    delete params['filter[2][data][comparison]'];
    delete params['filter[2][field]'];
    delete params['filter[2][data][value]'];
    params['sort'] = 'created_at';
    if (onlyDate) {
        params['filter[0][field]'] = 'created_at';
    }
    contactGrid.on('rowdblclick', function(grid, rowIndex, e) { 
        var row = contactGrid.getStore().getAt(rowIndex);
        window.location = action.contact.replace(/\.id\./, row.id);
    });
    contactGrid.render();
    dsContact.baseParams = params;
    dsContact.load();
    if (onlyDate) {
        params['filter[0][field]'] = 'created_at';
    }
    searchGrid.on('rowdblclick', function(grid, rowIndex, e) { 
        var row = searchGrid.getStore().getAt(rowIndex);
        window.location = action.search.replace(/\.id\./, row.id);
    });
    searchGrid.render();
    dsSearch.baseParams = params;
    dsSearch.load();
    
    params = {
        'start' : 0,
        'limit' : 5,
        'dir'   :  'DESC'
    }
    if (currentSiteId != 0 )
    {
         params['siteId'] = currentSiteId;   
    }
    bestViewGrid.on('rowdblclick', function(grid, rowIndex, e) { 
        var row = bestViewGrid.getStore().getAt(rowIndex);
        window.location = action.product.replace(/\.id\./, row.id).replace(/\.siteId\./,currentSiteId);
    });
    bestViewGrid.render();
    dsBestView.baseParams = params;
    dsBestView.load();
    
    bestsellerGrid.on('rowdblclick', function(grid, rowIndex, e) { 
        var row = bestsellerGrid.getStore().getAt(rowIndex);
        window.location = action.product.replace(/\.id\./, row.id).replace(/\.siteId\./,currentSiteId); 
    });
    delete params['dir'];
    bestsellerGrid.render();
    dsBestseller.baseParams = params;
    dsBestseller.load();
    
    // basic tabs 1, built from existing content
    var orderTabs = new Ext.TabPanel({
        renderTo: 'quick-orders-content',
        width:400,
        activeTab: 0,
        border: false,
        defaults:{autoHeight: true},
        items:[
            {contentEl:'orders-grid', title: 'Orders'.l()},
            {contentEl:'customer-grid', title: 'Customers'.l()},
            {contentEl:'contact-grid', title: 'Messages'.l()}
        ]
    });
    
    var orders = new Ext.Panel({
        title: 'Orders'.l(),
        collapsible:true,
        renderTo: 'quick-orders-dashboard',
        width:400,
        items:[
            {contentEl:'quick-orders-content', border: false}
        ]
    });
    
    
    var productsTabs = new Ext.TabPanel({
        renderTo: 'quick-products-content',
        width:400,
        activeTab: 0,
        border: false,
        //frame:true,
        defaults:{autoHeight: true},
        items:[
            {contentEl:'bestview-grid', title: 'Best viewed'.l()},
            {contentEl:'bestseller-grid', title: 'Bestsellers'.l()},
            {contentEl:'search-grid', title: 'Search Terms'.l()}
        ]
    });
    var products = new Ext.Panel({
        title: 'Products'.l(),
        collapsible:true,
        renderTo: 'quick-products-dashboard',
        width:400,
        items:[
            {contentEl:'quick-products-content', border: false}
        ]
    });
    if (renderSites) {
        var sites = new Ext.Panel({
            title: 'Sites'.l(),
            collapsible:false,
            bodyStyle: "padding:5px",
            renderTo: 'quick-sites-dashboard',
            width:400,
            items:[
                {
                    contentEl:'sites-form', 
                    border: false
                }
            ]
        });
        //if (typeof(currentSitetId) !== "undefined"){
            $('#site_id').val(currentSiteId);
        //}
    }
});