<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Auth
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Auth
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Auth_FrontAdapter implements Zend_Auth_Adapter_Interface
{
    /**
     *
     * @var string
     */
    private $_username;

    /**
     *
     * @var string
     */
    private $_password;

    /**
     *
     * @param string $username
     * @param string $password
     */
    public function __construct($username, $password)
    {
        $this->_username = $username;
        $this->_password = $password;
    }

    /**
     *
     * @return Zend_Auth_Result 
     */
    public function authenticate()
    {
        $row = Ecart::single('account/customer')->fetchRow(
            " email = '" . $this->_username . "' AND is_active = 1 " 
        );
        $messages = array();
        if (!$row) {
            $code = Zend_Auth_Result::FAILURE_IDENTITY_NOT_FOUND;
            $messages[] = Ecart::translate('account')->__(
                'Username or password is incorrect'
            );
            return new Zend_Auth_Result($code, null, $messages);
        } elseif ($row->password != md5($this->_password)) {
            $code = Zend_Auth_Result::FAILURE_CREDENTIAL_INVALID;
            $messages[] = Ecart::translate('account')->__(
                'Username or password is incorrect'
            );
        } else {
            $code = Zend_Auth_Result::SUCCESS;
        }

        return new Zend_Auth_Result($code, $row->id, $messages);
    }
}