<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Account
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Account
 * @subpackage  Collect
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Collect_CustomerGroup implements Ecart_Collect_Interface
{
    /**
     *
     * @static
     * @return array
     */
    public static function collect()
    {
        return Ecart::single('account/customer_group')
            ->fetchPairs('id', 'name');
    }

    /**
     *
     * @static
     * @param int $id
     * @return mixed string|void
     */
    public static function getName($id)
    {
        if (!$id) return '';
        return Ecart::single('account/customer_group')->getNameById($id);
    }
}