<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Core
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Core
 * @subpackage  Handler
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
interface Ecart_Collect_Handler_Interface
{
    /**
     * Add params
     *
     * @static
     * @param  array $params
     * @return string
     */
    public static function getSaveValue($params);
    
    /**
     * Get html
     *
     * @static
     * @param string $value
     * @return string
     */ 
    public static function getHtml($value, Zend_View_Interface $view = null);
    
    /**
     * Get config
     *
     * @static
     * @param  string $value
     * @return mixed
     */ 
    public static function getConfig($value);
}
