<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Mail
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Mail
 * @subpackage  Collect
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Collect_MailTemplate implements Ecart_Collect_Interface
{
    /**
     *
     * @static
     * @var array
     */
    private static $_templates;

    /**
     *
     * @static
     * @return array
     */
    public static function collect()
    {
        if (null === self::$_templates) {
            $path = Ecart::config()->system->path . '/app/design/mail';
            $templates = array();
            if (!file_exists($path))
                return false;
            $dh = opendir($path);
            
            while (($file = readdir($dh))) {
                
                if (!is_dir($path . '/' . $file) && 
                    substr($file, -11) == '_html.phtml' &&
                    is_file($path . '/' . substr($file, 0, -11) . '_txt.phtml')
                   )
                $templates[substr($file, 0, -11)] = substr($file, 0, -11);
            }
            
            closedir($dh);
            self::$_templates = $templates;
        }
        return self::$_templates;
    }

    /**
     *
     * @static
     * @param string $id
     * @return string
     */
    public static function getName($id)
    {
        $this->collect(); 
        return self::$_templates[$id];
    }
}