<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Locale
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Locale
 * @subpackage  Collect
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Collect_ZendCountry implements Ecart_Collect_Interface
{
    /**
     *
     * @static
     * @return array
     */
    public static function collect()
    {
        $options    = array();
        $locale = Ecart_Locale::getLocale();
        
        $countries = $locale->getTranslationList('territory', $locale, 2);
        
        if (!$countries) {
            $countries = $locale->getTranslationList('territory', Ecart_Locale::DEFAULT_LOCALE, 2);
        }
        
        return $countries;
    }

    /**
     *
     * @static
     * @param string $id
     * @return string
     */
    public static function getName($id)
    {
        if (empty($id)) {
            return;
        }
        $locale = Ecart_Locale::getLocale();
        $name  = $locale->getTranslation($id, 'country', $locale);
        
        return empty($name) ? $id : $name . ' (' . $id . ')';
    }
}