<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Locale
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Locale
 * @subpackage  Collect
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_Collect_ZendTimezone implements Ecart_Collect_Interface
{
    /**
     *
     * @static
     * @return array
     */
    public static function collect()
    {
        $options= array();
        $locale = Ecart_Locale::getLocale();
        $zones  = $locale->getTranslationList('WindowsToTimezone', $locale);
        
        if (!$zones) {
            $zones  = $locale->getTranslationList('WindowsToTimezone', Ecart_Locale::DEFAULT_LOCALE);
        }
        
        asort($zones);
        foreach ($zones as $code => $name) {
            $name = trim($name);
            $options[$code] =  empty($name) ? $code : $name . ' (' . $code . ')';
        }
        return $options;
    }

    /**
     *
     * @static
     * @param string $id
     * @return mixed string|void
     */
    public static function getName($id)
    {
        if (empty($id)) {
            return;
        }
        $locale = Ecart_Locale::getLocale();
        $name  = $locale->getTranslation($id, 'WindowsToTimezone', $locale);
        
        return empty($name) ? $id : $name . ' (' . $id . ')';
    }
}