<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Payment
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_Payment
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_CreditCard extends Ecart_Object
{
    public function getData($name = null)
    {
        $crypt = Ecart_Crypt::factory();
        if (isset($this->_data[$name])) {
            return $crypt->decrypt($this->_data[$name]);
        }
        return null;
    }

    public function setData($name, $value)
    {
        $crypt = Ecart_Crypt::factory();
        $value = empty($value) ? null : $crypt->encrypt($value);
        $this->_data[$name] = $value;
        return $this;
    }
}