<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_Shipping
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_View
 * @subpackage  Helper
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_View_Helper_AddJsValidateTranslation
{
    public function addJsValidateTranslation()
    {
        if (file_exists('js/jquery/validate/localization/messages_' . Ecart_Locale::getLocale()->toString() . '.js')) {
            $this->view->headScript()->appendFile(
                'js/jquery/validate/localization/messages_' . Ecart_Locale::getLocale()->toString() . '.js'
            );
        } elseif (file_exists('js/jquery/validate/localization/messages_' . Ecart_Locale::getLocale()->getLanguage() . '.js')) {
            $this->view->headScript()->appendFile(
                'js/jquery/validate/localization/messages_' . Ecart_Locale::getLocale()->getLanguage() . '.js'
            );
        }
    }
    
    public function setView($view)
    {
        $this->view = $view;
    }
}