<?php
/**
 * Ecart
 *
 * This file is part of Ecart.
 *
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Ecart
 * @package     Ecart_View
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/**
 * 
 * @category    Ecart
 * @package     Ecart_View
 * @subpackage  Helper
 * @author      Ecart Core Team <core@ecartcommerce.com>
 */
class Ecart_View_Helper_Price
{
    /**
     * @var Ecart_Locale_Model_Currency
     */
    private $_currency;

    public function __construct()
    {
        $this->_currency = Ecart::single('locale/currency');
    }

    /**
     *
     * @param float $price
     * @param bool $priceDiscount [optional]
     * @param mixed float|bool $useRate [optional]
     * @param string $code [optional]
     * @return string
     */
    public function price($price, $priceDiscount = false, $useRate = true, $code  = '')
    {
        // @todo from - to
        if (is_array($price)) {
            /*$priceFrom = $this->_currency->toCurrency($price['from'], $useRate, $code);
            $priceTo = $this->_currency->toCurrency($price['to'], $useRate, $code);

            return '<span class="price">' . $priceFrom . '</span> - <span class="price">' . $priceTo . '</span>';
*/            $price = $price['price'];
        } /*elseif*/
        if (false !== $priceDiscount
            && !empty($priceDiscount)
            && $price != $priceDiscount) {

            $priceSave = $this->_currency->toCurrency($price - $priceDiscount);
            $price = $this->_currency->toCurrency($price, $useRate, $code);
            $priceDiscount = $this->_currency->toCurrency(
                $priceDiscount, $useRate, $code
            );

            return '<div class="price-box"><p class="old-price">'
                 . '<span class="label">' . Ecart::translate('catalog')->__('Regular price') . ':</span> '
                 . '<span class="price">' . $price . '</span></p>'
                 . '<p class="special-price">'
                 . '<span class="label">' . Ecart::translate('catalog')->__('Special price') . ':</span> '
             . '<span class="price">' . $priceDiscount . '</span></p>'
                 . '<p class="save-price">'
                 . '<span class="label">' . Ecart::translate('catalog')->__('You save') . ':</span> '
                 . '<span class="price">' . $priceSave . '</span></p></div>';
        } 
        $price = $this->_currency->toCurrency($price, $useRate, $code);
        return '<div class="price-box"><p class="regular-price">'
            . '<span class="label">' . Ecart::translate('catalog')->__('Price') . ':</span> '
            . '<span class="price">' . $price . '</span></p></div>';
    }
}