<?php
/**
 * Ecart
 * 
 * This file is part of Ecart.
 * 
 * Ecart is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Ecart is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Ecart.  If not, see <http://www.gnu.org/licenses/>.
 *
 * @category    Ecart
 * @package     Ecart_Core
 * @copyright   Copyright 2008-2009 E-Cart LLC
 * @license     GNU Public License V3.0
 */

/* load base config */
if (class_exists('Ecart'))
    $root = Ecart::config()->system->path;
else
    $root = rtrim(str_replace('scripts', '', dirname(realpath(__FILE__))), '/\\');

require $root . '/app/etc/config.php';
/*
 * set optimal directory order for __autoload  function
 */
set_include_path(
    $config['system']['path'] . '/library'  . PATH_SEPARATOR 
  . $config['system']['path'] . '/app/code' . PATH_SEPARATOR 
  . get_include_path()
);



/*
 * Autoload function
 */
require_once 'Zend/Loader/Autoloader.php';
$autoloader = Zend_Loader_Autoloader::getInstance();
$autoloader->registerNamespace(array('Ecart'));

/*
 * Init config
 */
$config = new Ecart_Config($config, true);

/**
 * init database
 */
$db = Zend_Db::factory('Pdo_Mysql', array(
    'host'      => $config->db->host,
    'username'  => $config->db->username,
    'password'  => $config->db->password,
    'dbname'    => $config->db->dbname
));

Zend_Db_Table_Abstract::setDefaultAdapter($db);
//Ecart_Config::setDefaultDbAdapter($db); 

/*
 * Init cache system
 */
$frontendOptions = array(
   'lifetime' => 7200,
   'automatic_serialization' => true
);
$backendOptions = array(
    'cache_dir' => $root . '/var/cache/'
);
$cache = Zend_Cache::factory('Core', 'File', $frontendOptions, $backendOptions);
Zend_Db_Table_Abstract::setDefaultMetadataCache($cache);

Zend_Registry::set('config', $config);
Zend_Registry::set('db', $db);
Zend_Registry::set('cache', $cache);